#include <iostream>

using namespace std;

long long int f(int a[],int k,int l,int r)
{
    long long int suma=0;
    if(k==0)
    {
        for(int i=l;i<=r;i++)
        {
            suma+=a[i];
            suma%=1000000007;
        }
        return suma;
    }
    if(k==1)
    {
        for(int i=l;i<=r;i++)
        {
            suma+=((i+1)*(r+1-i)*a[i]);
            suma%=1000000007;
        }
        return suma;
    }
    for(int i=l;i<=r;i++)
    {
        for(int j=i;j<=r;j++)
        {
            suma=(suma+f(a,k-1,i,j))%1000000007;
        }
    }
    return suma;
}

int main()
{   int n,k;
    cin>>n>>k;
    int a[200000];
    for(int i=0;i<n;i++)
        cin>>a[i];
    long long int suma=f(a,k,0,n-1);
    cout << suma << endl;
    return 0;
}